version: "3.8"

services:
  pureftpd:
    image: {{ ftpserver_pureftp_image }}
    container_name: pureftpd
    ports:
      - "16421:2100"
      - "30000-30049:30000-30049"
    volumes:
      - "{{ ftpserver_conf }}:/data"
      - "{{ ftpserver_data }}:/home"
    environment:
      - "TZ=Europe/Paris"
      - "AUTH_METHOD=puredb"
      - "SECURE_MODE=false" # additional flags are in separated file
      - "PASSIVE_PORT_RANGE=30000:30049"
      - "PASSIVE_IP={{ ftpserver_passiv_ip }}"
    restart: always
  nginx:
    container_name: nginx
    image: {{ ftpserver_nginx_image }}
    volumes:
      - {{ ftpserver_nginx_conf }}/nginx.conf:/etc/nginx/conf.d/default.conf
      - {{ global_cert_path }}/live/{{ cert_domain }}/fullchain.pem:/etc/nginx/ssl/ftpserver.pem:ro
      - {{ global_cert_path }}/live/{{ cert_domain }}/privkey.pem:/etc/nginx/ssl/ftpserver.key:ro
      - {{ global_cert_path }}/live/{{ sftpgo_domain }}/fullchain.pem:/etc/nginx/ssl/sftpserver.pem:ro
      - {{ global_cert_path }}/live/{{ sftpgo_domain }}/privkey.pem:/etc/nginx/ssl/sftpserver.key:ro
      - {{ ftpserver_data }}/public:/srv:ro
    ports:
      - "443:443"
      - "80:80"
    environment:
      - "TZ=Europe/Paris"
    restart: always
  sftpgo:
    image: {{ ftpserver_sftpgo_image }}
    container_name: sftpgo
    ports:
      - "2022:2022"  # SFTP port
      - "2023:2023"  # FTP 
      - "8080:8080"  # Admin web interface (HTTP)
      - "50000-50100:50000-50100" # passive ports
    environment:
      SFTPGO_FTPD__BINDINGS__0__PORT: "2023"
      SFTPGO_FTPD__BINDINGS__0__CERTIFICATE_FILE: "/var/lib/sftpgo/fullchain.pem"
      SFTPGO_FTPD__BINDINGS__0__CERTIFICATE_KEY_FILE: "/var/lib/sftpgo/privkey.pem"
      SFTPGO_FTPD__BINDINGS__0__TLS_MODE: 2
      SFTPGO_FTPD__BINDINGS__0__FORCE_PASSIVE_IP: "{{ ftpserver_passiv_ip }}"
    volumes:
      - "{{ ftpserver_sftpgo_conf }}:/var/lib/sftpgo"
